Initial add of icinga to fix bug 271339
authorMatt Thode <prometheanfire@gentoo.org>
Tue, 15 Nov 2011 00:14:29 +0000 (00:14 +0000)
committerMatt Thode <prometheanfire@gentoo.org>
Tue, 15 Nov 2011 00:14:29 +0000 (00:14 +0000)
Package-Manager: portage-2.1.10.11/cvs/Linux x86_64

net-analyzer/icinga/ChangeLog [new file with mode: 0644]
net-analyzer/icinga/Manifest [new file with mode: 0644]
net-analyzer/icinga/files/icinga-apache.conf [new file with mode: 0644]
net-analyzer/icinga/files/icinga-conf.d [new file with mode: 0644]
net-analyzer/icinga/files/icinga-init.d [new file with mode: 0644]
net-analyzer/icinga/files/icinga-lighty.conf [new file with mode: 0644]
net-analyzer/icinga/files/ido2db-conf.d [new file with mode: 0644]
net-analyzer/icinga/files/ido2db-init.d [new file with mode: 0644]
net-analyzer/icinga/icinga-1.5.1.ebuild [new file with mode: 0644]
net-analyzer/icinga/metadata.xml [new file with mode: 0644]

diff --git a/net-analyzer/icinga/ChangeLog b/net-analyzer/icinga/ChangeLog
new file mode 100644 (file)
index 0000000..0e8fa8c
--- /dev/null
@@ -0,0 +1,12 @@
+# ChangeLog for net-analyzer/icinga
+# Copyright 1999-2011 Gentoo Foundation; Distributed under the GPL v2
+# $Header: /var/cvsroot/gentoo-x86/net-analyzer/icinga/ChangeLog,v 1.1 2011/11/15 00:14:29 prometheanfire Exp $
+
+*icinga-1.5.1 (15 Nov 2011)
+
+  15 Nov 2011; mthode <mthode@gentoo.org> +files/icinga-apache.conf,
+  +files/icinga-conf.d, +files/icinga-init.d, +files/icinga-lighty.conf,
+  +files/ido2db-conf.d, +icinga-1.5.1.ebuild, +files/ido2db-init.d,
+  +metadata.xml:
+  New ebuild for icinga. Writen by Prometheanfire. Fixes bug #271339.
+
diff --git a/net-analyzer/icinga/Manifest b/net-analyzer/icinga/Manifest
new file mode 100644 (file)
index 0000000..a51fc94
--- /dev/null
@@ -0,0 +1,10 @@
+AUX icinga-apache.conf 377 RMD160 bd009d51035802deb5efd3aaf0b726ca7ef34e2e SHA1 7ba572b8ed52695a8278cc5d57df3fd8cf59dca8 SHA256 e2a17742d8a74f31fd038cbf33533ccdeaed8604cfa026d0fdbb24d3a46e30f9
+AUX icinga-conf.d 178 RMD160 3e8a497619b16ce9e33a8d6ff824b5e5cc8f9c63 SHA1 7824227018db79beb7984cdedda7345fe54f70aa SHA256 68dde656424fc57e66babceb3c6623a235fac8bf1f9cd885138e31878db740db
+AUX icinga-init.d 1207 RMD160 fe0f17d9247da24208281077b6cb46089dc9f22f SHA1 58c8fc60da8f4fb5a7d29a8be83948e11a8719e4 SHA256 d9014a1ce527282e5a404e602b3f08e0a4b842e02bd2fcdd8fffb8e67922557d
+AUX icinga-lighty.conf 465 RMD160 34de76ad07f95e2282ae3e192b35cd9310ef2b4e SHA1 0d74cc2936327121f07b61fb1a348ce66035bfbb SHA256 f4059bc54959fb2544f23c2fc6a86f0ab2467025ce1f468317a0079b55116b44
+AUX ido2db-conf.d 35 RMD160 a2bb1738720a56285da529fb18eeb60739ac817b SHA1 57ba29aec3f80db9577da4aca34d228487dd12c1 SHA256 6cbdf0eb7070121bd466c221d73cf6ca05a4af5caa1d4abedf62828edd1b1372
+AUX ido2db-init.d 924 RMD160 b4756574f38fed0fc85ecfae1bf353a4811fa4e2 SHA1 f7bf09a34fe55dd49c3381ca11781a643e4d1ca0 SHA256 88913ba8d8d2824e52ea26d93bdb7587d6ab53020546a6a98c9e9d337cc17985
+DIST icinga-1.5.1.tar.gz 16518659 RMD160 972d1e4dd49fdddf32970868bd16964c7e3cd87d SHA1 61bd47535e9f49e63e0ee1ef2bb56d62e6893418 SHA256 b2cc23ab8b96e9409ce3e7ed4a0e1aabea7f9b4e9d521f5ed23a99ea1c9ec37b
+EBUILD icinga-1.5.1.ebuild 6071 RMD160 db24a167513611561c27f9660523e0e640bad100 SHA1 ea304d5f6db7ce55b154f2fd9b1ae2e9df15607b SHA256 336cc87bb9eed1f84ac35fd4c6719b4979e6c5acac4a52ae60517129e098bd8f
+MISC ChangeLog 546 RMD160 b27c6e609ad676d8009a571af32611c03ecf36c2 SHA1 de59ee40c3b61a06b1984eb0e94c16a1b1b6f88d SHA256 987df09fd9a4d7868b58a4762a0f1d9ce2f20705fad202633a83915c3d93f84f
+MISC metadata.xml 614 RMD160 bd86f9fb8e1911deaedaf6e7983e9de3a9e749d4 SHA1 b0ab4641480b5342c67a00edb4bc0bdc1745ca81 SHA256 3814e6b4e6f2d2b42cd82f090136270e834057a170435670c156435e9188ec2d
diff --git a/net-analyzer/icinga/files/icinga-apache.conf b/net-analyzer/icinga/files/icinga-apache.conf
new file mode 100644 (file)
index 0000000..e1a0199
--- /dev/null
@@ -0,0 +1,15 @@
+<IfDefine ICINGA>
+       ScriptAlias /icinga/cgi-bin/ /usr/lib/icinga/cgi-bin/
+       <Directory "/usr/lib/icinga/cgi-bin/">
+               AllowOverride AuthConfig
+               Options ExecCGI
+               Order allow,deny
+               Allow from all
+       </Directory>
+       Alias /icinga /usr/share/icinga/htdocs
+       <Directory "/usr/share/icinga/htdocs">
+               AllowOverride AuthConfig
+               Order allow,deny
+               Allow from all
+       </Directory>
+</IfDefine>
diff --git a/net-analyzer/icinga/files/icinga-conf.d b/net-analyzer/icinga/files/icinga-conf.d
new file mode 100644 (file)
index 0000000..da5b324
--- /dev/null
@@ -0,0 +1,3 @@
+# Distributed monitoring users will want to configure here the ip/hostname of the central server.
+# It will be used by submit_check_result_via_nsca.
+NAGIOS_NSCA_HOST="localhost"
diff --git a/net-analyzer/icinga/files/icinga-init.d b/net-analyzer/icinga/files/icinga-init.d
new file mode 100644 (file)
index 0000000..f734f71
--- /dev/null
@@ -0,0 +1,50 @@
+#!/sbin/runscript
+
+opts="${opts} reload checkconfig"
+
+depend() {
+       need net
+       use dns logger firewall
+       after mysql postgresql
+}
+
+reload()
+{
+       checkconfig || return 1
+       ebegin "Reloading configuration"
+       killall -HUP icinga &>/dev/null
+       eend $?
+}
+
+checkconfig() {
+       # Silent Check
+       /usr/sbin/icinga -v /etc/icinga/icinga.cfg &>/dev/null && return 0
+       # Now we know there's problem - run again and display errors
+       /usr/sbin/icinga -v /etc/icinga/icinga.cfg
+       eend $? "Configuration Error. Please fix your configfile"
+}
+
+start() {
+       checkconfig || return 1
+       ebegin "Starting icinga"
+       touch /var/icinga/icinga.log /var/icinga/status.sav
+       chown icinga:icinga /var/icinga/icinga.log /var/icinga/status.sav
+       rm -f /var/icinga/rw/icinga.cmd
+       start-stop-daemon --quiet --start --startas /usr/sbin/icinga -e HOME="/var/icinga/home" --pidfile /var/icinga/icinga.lock -- -d /etc/icinga/icinga.cfg
+       eend $?
+}
+
+stop() {
+       ebegin "Stopping icinga"
+       start-stop-daemon --quiet --stop --pidfile /var/icinga/icinga.lock
+       rm -f /var/icinga/status.log /var/icinga/icinga.tmp /var/icinga/icinga.lock /var/icinga/rw/icinga.cmd
+       eend $?
+}
+
+svc_restart() {
+       checkconfig || return 1
+       ebegin "Restarting icinga"
+       svc_stop
+       svc_start
+       eend $?
+}
diff --git a/net-analyzer/icinga/files/icinga-lighty.conf b/net-analyzer/icinga/files/icinga-lighty.conf
new file mode 100644 (file)
index 0000000..678f233
--- /dev/null
@@ -0,0 +1,24 @@
+server.modules += ("mod_cgi")
+server.modules += ("mod_auth")
+server.modules += ("mod_alias")
+
+auth.require += ( "/icinga" =>
+       (
+               "method"  => "digest",
+               "realm"   => "icinga",
+               "require" => "valid-user"
+       )
+)
+
+$HTTP["url"] =~ "^/icinga/cgi-bin/" {
+       dir-listing.activate = "disable"
+       cgi.assign = (
+               ".pl"  => "/usr/bin/perl",
+               ".cgi" => ""
+       )
+}
+
+alias.url += (
+       "/icinga/cgi-bin" => "/usr/lib/icinga/cgi-bin",
+       "/icinga"         => "/usr/share/icinga/htdocs"
+)
diff --git a/net-analyzer/icinga/files/ido2db-conf.d b/net-analyzer/icinga/files/ido2db-conf.d
new file mode 100644 (file)
index 0000000..5429fa9
--- /dev/null
@@ -0,0 +1 @@
+IDO2DBCFG="/etc/icinga/ido2db.cfg"
diff --git a/net-analyzer/icinga/files/ido2db-init.d b/net-analyzer/icinga/files/ido2db-init.d
new file mode 100644 (file)
index 0000000..75051ab
--- /dev/null
@@ -0,0 +1,35 @@
+#!/sbin/runscript
+# Copyright 1999-2011 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/net-analyzer/icinga/files/ido2db-init.d,v 1.1 2011/11/15 00:14:29 prometheanfire Exp $
+
+IDO2DBBIN="/usr/sbin/ido2db"
+SOCKET="/var/icinga/ido.sock"
+
+function check() {
+       if [ -S "${SOCKET}" ] ; then
+               ewarn "Strange, the socket file already exist in \"${SOCKET}\""
+               ewarn "it will be removed now and re-created by ido2db"
+               ewarn "BUT please make your checks."
+               rm -f "${SOCKET}"
+       fi
+}
+
+depend() {
+       need net
+       use dns logger firewall
+       after mysql postgresql
+}
+
+start() {
+       check
+       ebegin "Starting ido2db"
+       start-stop-daemon --quiet --start --pidfile /var/icinga/ido2db.lock --startas ${IDO2DBBIN} -- -c ${IDO2DBCFG}
+       eend $?
+}
+
+stop() {
+       ebegin "Stopping ido2db"
+       start-stop-daemon --quiet --stop --pidfile /var/icinga/ido2db.lock --name /usr/sbin/ido2db
+       eend $?
+}
diff --git a/net-analyzer/icinga/icinga-1.5.1.ebuild b/net-analyzer/icinga/icinga-1.5.1.ebuild
new file mode 100644 (file)
index 0000000..c98fcb2
--- /dev/null
@@ -0,0 +1,215 @@
+# Copyright 1999-2011 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/net-analyzer/icinga/icinga-1.5.1.ebuild,v 1.1 2011/11/15 00:14:29 prometheanfire Exp $
+
+EAPI=2
+
+inherit depend.apache eutils multilib toolchain-funcs
+
+DESCRIPTION="Nagios Fork - Check daemon, CGIs, docs, IDOutils"
+HOMEPAGE="http://www.icinga.org/"
+SRC_URI="mirror://sourceforge/${PN}/${P}.tar.gz"
+
+LICENSE="GPL-2"
+SLOT="0"
+KEYWORDS="~amd64 ~x86"
+IUSE="+apache2 api debug +idoutils lighttpd +mysql perl plugins postgres ssl +vim-syntax +web"
+DEPEND="idoutils? ( dev-db/libdbi-drivers[mysql?,postgres?] )
+       perl? ( dev-lang/perl )
+       virtual/mailx
+       web? (
+               media-libs/gd[jpeg,png]
+               lighttpd? ( www-servers/lighttpd dev-lang/php[cgi] )
+               apache2? ( || ( dev-lang/php[apache2] dev-lang/php[cgi] ) )
+       )
+       !net-analyzer/nagios-core"
+RDEPEND="${DEPEND}
+       plugins? ( net-analyzer/nagios-plugins )"
+
+want_apache2
+
+pkg_setup() {
+       depend.apache_pkg_setup
+       enewgroup icinga
+       enewuser icinga -1 -1 /var/spool/icinga icinga -c "icinga alert"
+       if use web ; then
+               elog "This does not include cgis that are perl-dependent"
+               elog "Currently traceroute.cgi is perl-dependent"
+               elog "Note that the user your webserver is running as needs"
+               elog "read-access to /etc/icinga."
+               elog
+               if use apache2 || use lighttpd ; then
+                       elog "There are several possible solutions to accomplish this,"
+                       elog "choose the one you are most comfortable with:"
+                       elog
+                       if use apache2 ; then
+                               elog "  usermod -G icinga apache"
+                               elog "or"
+                               elog "  chown icinga:apache /etc/icinga"
+                               elog
+                               elog "Also edit /etc/conf.d/apache2 and add \"-D ICINGA\""
+                       elif use lighttpd ; then
+                               elog "  usermod -G icinga lighttpd "
+                               elog "or"
+                               elog "  chown icinga:lighttpd /etc/icinga"
+                               elog "Also edit /etc/lighttpd/lighttpd.conf and add 'include \"lighttpd_icinga.conf\"'"
+                       fi
+                       elog
+                       elog "That will make icinga's web front end visable via"
+                       elog "http://localhost/icinga/"
+                       elog
+               else
+                       elog "IMPORTANT: Do not forget to add the user your webserver"
+                       elog "is running as to the icinga group!"
+               fi
+
+       else
+               ewarn "Please note that you have installed Icinga without web interface."
+               ewarn "Please don't file any bugs about having no web interface when you do this."
+               ewarn "Thank you!"
+       fi
+
+}
+
+src_prepare() {
+       if use api ; then
+               sed -i -e 's/\(USE_ICINGAAPI=\)no/\1yes/g' Makefile.in || die "sed failed in Makefile.in"
+       fi
+}
+
+src_configure() {
+       local myconf
+       local myconf2
+
+       myconf="$(use_enable perl embedded-perl)
+       $(use_with perl perlcache)
+       $(use_enable idoutils)
+       $(use_enable ssl)
+       $(use_enable debug DEBUG0)
+       $(use_enable debug DEBUG1)
+       $(use_enable debug DEBUG2)
+       $(use_enable debug DEBUG3)
+       $(use_enable debug DEBUG4)
+       $(use_enable debug DEBUG5)
+       --disable-statuswrl
+       --with-cgiurl=/icinga/cgi-bin
+       --with-log-dir=/var/log/icinga"
+
+       myconf2="--bindir=/usr/sbin
+       --sbindir=/usr/$(get_libdir)/icinga/cgi-bin
+       --datarootdir=/usr/share/icinga/htdocs
+       --localstatedir=/var/icinga
+       --sysconfdir=/etc/icinga"
+
+       if use plugins ; then
+               myconf2+=" --libexecdir=/usr/$(get_libdir)/nagios/plugins"
+       else
+               myconf2+=" --libexecdir=/usr/$(get_libdir)/icinga/plugins"
+       fi
+
+       if use !apache2 && use !lighttpd ; then
+               myconf2+=" --with-command-group=icinga"
+       else
+               if use apache2 ; then
+                       myconf+=" --with-httpd-conf=/etc/apache2/conf.d"
+                       myconf2+=" --with-command-group=apache"
+               elif use lighttpd ; then
+                       myconf2+=" --with-command-group=lighttpd"
+               fi
+       fi
+
+       econf ${myconf} ${myconf2}
+       if use api ; then
+               cd module/icinga-api || die
+               econf ${myconf2}
+       fi
+}
+
+src_compile() {
+       tc-export CC
+
+       emake icinga || die "make failed"
+
+       if use web ; then
+               emake DESTDIR="${D}" cgis || die
+       fi
+
+       if use idoutils ; then
+               emake DESTDIR="${D}" idoutils || die
+       fi
+}
+
+src_install() {
+       dodoc Changelog README UPGRADING || die
+
+       if ! use web ; then
+               sed -i -e '/cd $(SRC_\(CGI\|HTM\))/d' Makefile || die
+       fi
+       sed -i -e 's/^contactgroups$//g' Makefile || die
+
+       emake DESTDIR="${D}" install{,-config,-commandmode} || die
+
+       if use idoutils ; then
+                emake DESTDIR="${D}" install-idoutils || die
+       fi
+       if use api ; then
+                emake DESTDIR="${D}" install-api || die
+       fi
+
+       newinitd "${FILESDIR}"/icinga-init.d icinga || die
+       newconfd "${FILESDIR}"/icinga-conf.d icinga || die
+       if use idoutils ; then
+               newinitd "${FILESDIR}"/ido2db-init.d ido2db || die
+               newconfd "${FILESDIR}"/ido2db-conf.d ido2db || die
+               insinto /usr/share/icinga/contrib/db
+               doins -r module/idoutils/db/* || die
+       fi
+       # Apache Module
+       if use web ; then
+               if use apache2 ; then
+                       insinto "${APACHE_MODULES_CONFDIR}"
+                       newins "${FILESDIR}"/icinga-apache.conf 99_icinga.conf || die
+               elif use lighttpd ; then
+                       insinto /etc/lighttpd
+                       newins "${FILESDIR}"/icinga-lighty.conf lighttpd_icinga.conf || die
+               else
+                       ewarn "${CATEGORY}/${PF} only supports Apache-2.x or Lighttpd webserver"
+                       ewarn "out-of-the-box. Since you are not using one of them, you"
+                       ewarn "have to configure your webserver accordingly yourself."
+               fi
+       fi
+
+       fowners -R root:root /usr/$(get_libdir)/icinga || die
+       cd "${D}" || die
+       find usr/$(get_libdir)/icinga -type d -exec fperms 755 {} +
+       find usr/$(get_libdir)/icinga/cgi-bin -type f -exec fperms 755 {} +
+
+       keepdir /etc/icinga
+       keepdir /var/icinga
+       keepdir /var/icinga/archives
+       keepdir /var/icinga/rw
+       keepdir /var/icinga/spool/checkresults
+
+       if use apache2 ; then
+               webserver=apache
+       elif use lighttpd ; then
+               webserver=lighttpd
+       else
+               webserver=icinga
+       fi
+       fowners -R icinga:${webserver} /var/icinga/rw || die "Failed chown of /var/icinga/rw"
+
+       fperms 6755 /var/icinga/rw || die "Failed Chmod of ${D}/var/icinga/rw"
+       fperms 0750 /etc/icinga || die "Failed chmod of ${D}/etc/icinga"
+}
+
+pkg_postinst() {
+       elog "If you want icinga to start at boot time"
+       elog "remember to execute:"
+       elog "  rc-update add icinga default"
+       elog
+       elog "If your kernel has /proc protection, icinga"
+       elog "will not be happy as it relies on accessing the proc"
+       elog "filesystem. You can fix this by adding icinga into"
+       elog "the group wheel, but this is not recomended."
+}
diff --git a/net-analyzer/icinga/metadata.xml b/net-analyzer/icinga/metadata.xml
new file mode 100644 (file)
index 0000000..bc77e2a
--- /dev/null
@@ -0,0 +1,16 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
+<pkgmetadata>
+       <herd>no-herd</herd>
+       <longdescription lang="en">A rebuild of nagios from the ground up</longdescription>
+       <use>
+               <flag name="api">Adds support for the icinga API</flag>
+               <flag name="idoutils">Adds DB support</flag>
+               <flag name="lighttpd">Adds Lighttpd support</flag>
+               <flag name="plugins">Adds support for nagios plugins</flag>
+               <flag name="web">Adds generic web interface support</flag>
+       </use>
+       <maintainer>
+               <email>prometheanfire@gentoo.org</email>
+       </maintainer>
+</pkgmetadata>